| AI Engine API User Guide (AIE-API) 2026.1

Loading...
Searching...
No Matches
aie::pattern_iterator< T, Steps > Class Template Reference

`#include <iterator.hpp>`

## Public Types
using | difference_type = ptrdiff_t
using | iterator_category = std::forward_iterator_tag
using | pointer = value_type*
using | reference = value_type&
using | value_type = T

## Public Member Functions
bool | operator!= (const pattern_iterator &other) const
| Return true if the two iterators reference different values.
reference | operator* ()
| Accesses the value in the iterator.
pattern_iterator & | operator++ ()
| Pre-fix increment: advances the iterator one step.
pattern_iterator | operator++ (int)
| Post-fix increment: advances the iterator one step and returns a copy of its old state.
pointer | operator-> ()
| Accesses the value in the iterator.
bool | operator== (const pattern_iterator &other) const
| Return true if the two iterators reference the same value.

## Member Typedef Documentation

## ◆ difference_type

template<typename T, unsigned Steps>

using aie::pattern_iterator< T, Steps >::difference_type = ptrdiff_t

## ◆ iterator_category

template<typename T, unsigned Steps>

using aie::pattern_iterator< T, Steps >::iterator_category = std::forward_iterator_tag

## ◆ pointer

template<typename T, unsigned Steps>

using aie::pattern_iterator< T, Steps >::pointer = value_type*

## ◆ reference

template<typename T, unsigned Steps>

using aie::pattern_iterator< T, Steps >::reference = value_type&

## ◆ value_type

template<typename T, unsigned Steps>

using aie::pattern_iterator< T, Steps >::value_type = T

## Member Function Documentation

## ◆ operator!=()

template<typename T, unsigned Steps>

bool aie::pattern_iterator< T, Steps >::operator!= | ( | const pattern_iterator< T, Steps > & | other | ) | const
| inline

Return true if the two iterators reference different values.

## ◆ operator*()

template<typename T, unsigned Steps>

reference aie::pattern_iterator< T, Steps >::operator* | ( |  | ) |
| inline

Accesses the value in the iterator.

## ◆ operator++() [1/2]

template<typename T, unsigned Steps>

pattern_iterator & aie::pattern_iterator< T, Steps >::operator++ | ( |  | ) |
| inline

Pre-fix increment: advances the iterator one step.

Every time the iterator reaches the end, it jumps back to its base position.

Returns
  a reference to the iterator

See also
  operator++(int)

## ◆ operator++() [2/2]

template<typename T, unsigned Steps>

pattern_iterator aie::pattern_iterator< T, Steps >::operator++ | ( | int |  | ) |
| inline

Post-fix increment: advances the iterator one step and returns a copy of its old state.

Returns
  a copy of the iterator before the increment operation took place.

See also
  operator++()

## ◆ operator->()

template<typename T, unsigned Steps>

pointer aie::pattern_iterator< T, Steps >::operator-> | ( |  | ) |
| inline

Accesses the value in the iterator.

## ◆ operator==()

template<typename T, unsigned Steps>

bool aie::pattern_iterator< T, Steps >::operator== | ( | const pattern_iterator< T, Steps > & | other | ) | const
| inline

Return true if the two iterators reference the same value.

The documentation for this class was generated from the following file:

- iterator.hpp